#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <linux/types.h>
#include <ctype.h>
#include <string.h>

#include "lblib.h"

#define LOCAL_OFFSET 0x0
#define LOCAL_SIZE   0x10000
#define TRUE 1
#define FALSE 0

int error = 0;

int main(void)
{
    int loops=0;
    int passes=0;
	FILE *fp;
	int status1, status2,p;
	double loss;
    u_int32_t rval, val, blank, thresh, Rotime;
    u_int32_t L0total1, L0total2, L0gated1, L0gated2, L0time;
    char filename[13]; 
    printf("\n\n");
    if (lb_init(LOCAL_OFFSET, LOCAL_SIZE)) 
    {
		perror("local bus init");
		exit(errno);
    }
	printf("Insert number of points to acquire [dec]: ");
	scanf("%d",&p);
	printf("\nSet derandomizer UPPER occupancy [hex]: ");
    scanf("%x",&rval);
	val = rval<<4;
	printf("\nSet derandomizer LOWER occupancy [hex]: ");
    scanf("%x",&rval);
    Rotime = 35 <<8;
    rval = Rotime + rval + val;
	lb_write_word(0x101c,rval);
//    printf("%x",rval);
	printf("\nL0 random generator threshold [hex] : ");
	scanf("%x",&thresh);
    lb_write_word(0x1038, thresh);
 	printf("\nInsert file name [max 8 char] : " );
	scanf ("%s",filename);
	printf("%s",filename);
    lb_write_word(0x3004,0x800); //  reset counters
    lb_write_word(0x3004,0x0);
	lb_write_word(0x1004,0x80); // start triggers	
	if ((fp=fopen(filename,"w"))==NULL) {
		printf("Error opening file!");
		return 0; }
    for (;p>0;p--)
    {
		loops++;
		if (loops % 100 == 0) 
		{
			passes++;
			printf("Pass #%d, errors %d\n", passes, error);
			loops=0;
		}
//		status1 = lb_write_word(0x1000,0x0); // update for freja
		status1 = lb_read_word(0x300c, &blank); // update for odin
//		status2 = lb_read_word(0x1070, &rval); // read for freja
		status2 = lb_read_word(0x101c, &rval); // read for odin
		val = (rval & 0xF0000)>>16; // FIFO occupancy
		fprintf(fp,"%d\n",val);
    }
	fclose(fp);
    lb_write_word(0x1004,0x0); // stop triggers
	lb_read_word(0x300c, &blank); // update for odin
    lb_read_word(0x1104, &L0total1);
    lb_read_word(0x1108, &L0total2);
    lb_read_word(0x110c, &L0gated1);
	lb_read_word(0x1110, &L0gated2);
	lb_read_word(0X1124, &L0time); 
	printf("\n\nRESULTS :");
	printf("\nTotal number of L0 triggers accepts : %d %d",L0total2, L0total1);
	printf("\nGated number of L0 triggers accepts : %d %d",L0gated2, L0gated1);
    loss = ((double)L0total1-(double)L0gated1)/(double)L0total1;
	printf("\nTrigger loss : %.3f ",loss);
	printf("\nTotal time of global L0 inhibit : %d", L0time);
    printf("\n\n");
	return 1;
}

